renoise.tool():add_keybinding {
  name = "Global:Tools:Clear Junk Data",
  invoke = function()clear_junk_data()
  end  
}

renoise.tool():add_menu_entry {
  name = "Pattern Editor:Clear Junk Data",
  invoke = function() clear_junk_data()
  end
}

local my_dialog = nil
--------------------------------------------------------------
--main
--------------------------------------------------------------
function clear_junk_data()

--1 dialog at a time
if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
  my_dialog:close()
  return
end

--------------------------------------------------------------
--Local functions
--------------------------------------------------------------

local function get_number_of_tracks() 

local track_table = renoise.song().tracks
local note_tracks = 0  --incrementor
local NOTE_TRACK = 1

  for _,track in ipairs(track_table) do
   
    if track.type == NOTE_TRACK then
      note_tracks = note_tracks + 1
    end    
  end   
 return note_tracks
end

--------------------------------------------------------------
--constants 
--------------------------------------------------------------
local NOTE_OFF = 120
local EMPTY_NOTE_CELL = 121
local NOTE_TRACK = 1

-- total_patterns
local total_patterns = #renoise.song().patterns
local max_vb

if total_patterns == 1 then
  max_vb = 2
else max_vb = #renoise.song().patterns
end
--------------------------------------------------------------
--GUI
--------------------------------------------------------------
local vb = renoise.ViewBuilder()


local title = "Clear Junk Data"
local dialog_content = vb:column {
                        margin = 4,
                        
                        vb:vertical_aligner {
                         mode = "distribute",
                         spacing = 8,
                        
                        vb:column {
                         style = "group",
                         margin = 4,
                         
                        vb:text {
                         text = "Range:" 
                        },
                        
                        vb:popup {
                         value = 1,
                         id = "popup",
                         width = 120,
                         items = {"Track in Pattern","Selection in Pattern","Current Pattern", "Track in Song","Pattern Range...","Whole Song"},
                          notifier = function()
                         --enable buttons
                           if vb.views["popup"].value == 5 then
                             vb.views["box1"].visible = true
                             vb.views["box2"].visible = true
                           else
                             vb.views["box1"].visible = false
                             vb.views["box2"].visible = false   
                           end
                         end  --fn             
                         },
                         
                         
                         vb:horizontal_aligner {  --- pattern range
                          mode = "left",
     
                          vb:valuebox {
                           value = 0,
                           min = 0,
                           max = max_vb -1,
                           visible = false,
                           id = "box1"
                           --fn 
                          },
                          vb:valuebox {
                           value = 1,
                           min = 0,
                           max = max_vb -1,
                           visible = false,
                           id = "box2"
                          },
                         },
                        },--column
                        
                        vb:column {
                         style = "group",
                         margin = 1,
                         
                        vb:text {
                         text = "What to Clear:" 
                        },
                         
                        vb:row {
                         margin = 4,
                        
                        vb:switch {
                         value = 1,
                         id = "switch",
                         items = {"Note Offs","Meta"},
                         width = 118
                        },
                       
                        
                       },
                      },
                        
                        vb:horizontal_aligner {
                         mode = "center",
                         margin = 4,
                        
                        vb:button {
                         text = "Clear!",
                         id = "button",
                         height = 24,
                         width = 110,
                         
 notifier = function()
-----------------------------------------------------
--CLEAR REDUNDENT NOTE OFFS 
-----------------------------------------------------
--vb.views["button"].text = "Processing.."
renoise.app():show_status("Clear Junk Data Tool : (Clearing data...)")
local NOTE_OFF = 120
local EMPTY_NOTE_CELL = 121


local pattern_iter = renoise.song().pattern_iterator
local pattern_index = renoise.song().selected_pattern_index
local track_index = renoise.song().selected_track_index
local pattern_length = renoise.song().patterns[pattern_index].number_of_lines
local current_note_holder = 0
local all_patterns = #renoise.song().patterns
local total_patterns = #renoise.song().patterns

local current_pattern_track = renoise.song().patterns[pattern_index].tracks[track_index] 
local track_table = renoise.song().tracks
 
local all_note_tracks = get_number_of_tracks() --local function
  
if vb.views["switch"].value == 0 then    
---------------------------------------------
--"iterate" downwards: 1 column at a time
---------------------------------------------

if vb.views["popup"].value == 1 then --[TRACK IN PATTERN]


  for note_col = 1,12 do
    current_note_holder = 0 --reset for each column
      
    for line_index = 1, pattern_length do
      local note_columns = current_pattern_track:line(line_index).note_columns --table

     --if second note_off in column found then delete
      if current_note_holder == NOTE_OFF and note_columns[note_col].note_value == NOTE_OFF then
        note_columns[note_col].note_value = EMPTY_NOTE_CELL 
      end
   
     --note_off found so initialise holder
      if note_columns[note_col].note_value == NOTE_OFF then
        current_note_holder = NOTE_OFF
  
     --else note found so reset holder
      elseif note_columns[note_col].note_value < NOTE_OFF then
        current_note_holder = 0
      end
    end --for "lines in column"
  end --for "each column"


----------------------------------------------------------------------------------------------------------------
elseif vb.views["popup"].value == 2 then -- [SELECTION IN PATTERN] 


for my_note_tracks = 1, all_note_tracks do  --tracks
  local current_pattern_track = renoise.song().patterns[pattern_index].tracks[my_note_tracks]

 --"iterate" downwards: 1 column at a time
 ---------------------------------------------

  for note_col = 1,12 do
    current_note_holder = 0 --reset for each column
     
    for line_index = 1, pattern_length do
      local note_columns = current_pattern_track:line(line_index).note_columns --table
    

         --if second note_off in column found then delete
        if current_note_holder == NOTE_OFF and note_columns[note_col].note_value == NOTE_OFF then
          if note_columns[note_col].is_selected  then -- only clear if [SELECTED]
            note_columns[note_col].note_value = EMPTY_NOTE_CELL 
          end
        end
   
         --note_off found so initialise holder
        if note_columns[note_col].note_value == NOTE_OFF then
          current_note_holder = NOTE_OFF
  
         --else note found so reset holder
        elseif note_columns[note_col].note_value < NOTE_OFF then
          current_note_holder = 0
        end
      
    end --for "lines in column"    
  end --for "each column"
end --for "each track in pattern"

---------------------------------------------------------------------------------------------------------------------------
elseif vb.views["popup"].value == 3 then -- [PATTERN]


for my_note_tracks = 1, all_note_tracks do  --tracks
  local current_pattern_track = renoise.song().patterns[pattern_index].tracks[my_note_tracks]

 --"iterate" downwards: 1 column at a time
 ---------------------------------------------

  for note_col = 1,12 do
    current_note_holder = 0 --reset for each column
     
    for line_index = 1, pattern_length do
      local note_columns = current_pattern_track:line(line_index).note_columns --table

       --if second note_off in column found then delete
      if current_note_holder == NOTE_OFF and note_columns[note_col].note_value == NOTE_OFF then
        note_columns[note_col].note_value = EMPTY_NOTE_CELL 
      end
   
       --note_off found so initialise holder
      if note_columns[note_col].note_value == NOTE_OFF then
        current_note_holder = NOTE_OFF
  
       --else note found so reset holder
      elseif note_columns[note_col].note_value < NOTE_OFF then
        current_note_holder = 0
      end   
    end --for "lines in column"
  end --for "each column"
end --for "each track in pattern"


elseif vb.views["popup"].value == 4 then -- [TRACK IN SONG] 

local status_number = 0

for patterns = 1, all_patterns do
  local current_pattern_track = renoise.song().patterns[patterns].tracks[track_index]
 
  pattern_index = patterns
  status_number = status_number +1
  renoise.app():show_status("Clear Junk Data Tool: (Processing Pattern : "
  ..status_number.." / "..total_patterns..")")
 
 for note_col = 1,12 do
    current_note_holder = 0 --reset for each column
     
    for line_index = 1, pattern_length do
      local note_columns = current_pattern_track:line(line_index).note_columns --table

       --if second note_off in column found then delete
      if current_note_holder == NOTE_OFF and note_columns[note_col].note_value == NOTE_OFF then
        note_columns[note_col].note_value = EMPTY_NOTE_CELL 
      end
   
       --note_off found so initialise holder
      if note_columns[note_col].note_value == NOTE_OFF then
        current_note_holder = NOTE_OFF
  
       --else note found so reset holder
      elseif note_columns[note_col].note_value < NOTE_OFF then
        current_note_holder = 0
      end   
    end --for "lines in column"
  end --for "each column"
end --for "all patterns"


elseif vb.views["popup"].value == 5 then -- [PATTERNS FROM...]

local status_number = vb.views["box1"].value 

local reversed_box_values = false
local user_chosen_range_start = vb.views["box1"].value + 1
local user_chosen_range_end = vb.views["box2"].value + 1

-- when box 1 is greater than box 2 then swap
if user_chosen_range_start > user_chosen_range_end then
  reversed_box_values = true
  status_number = vb.views["box2"].value
  
  user_chosen_range_start = vb.views["box2"].value + 1
  user_chosen_range_end = vb.views["box1"].value + 1   
end

for patterns = user_chosen_range_start, user_chosen_range_end do
  pattern_index = patterns
  status_number = status_number +1
    
  renoise.app():show_status("Clear Junk Data Tool: (Processing Pattern : "
  ..status_number.." / "..user_chosen_range_end..")")
 
  
  for my_note_tracks = 1, all_note_tracks do  --tracks
    local current_pattern_track = renoise.song().patterns[pattern_index].tracks[my_note_tracks]

   --"iterate" downwards: 1 column at a time
   ---------------------------------------------

    for note_col = 1,12 do
      current_note_holder = 0 --reset for each column
      
      for line_index = 1, pattern_length do
        local note_columns = current_pattern_track:line(line_index).note_columns --table

       --if second note_off in column found then delete
        if current_note_holder == NOTE_OFF and note_columns[note_col].note_value == NOTE_OFF then
          note_columns[note_col].note_value = EMPTY_NOTE_CELL 
        end
   
       --note_off found so initialise holder
        if note_columns[note_col].note_value == NOTE_OFF then
          current_note_holder = NOTE_OFF
  
       --else note found so reset holder
        elseif note_columns[note_col].note_value < NOTE_OFF then
           current_note_holder = 0
        end 
      end --for "lines in column"
    end --for "each column"
  end --for "each track in pattern"
  
  if total_patterns == 1 then --hack due to max vb has to be 1
    break
  end
end --for "each pattern in song"




elseif vb.views["popup"].value == 6 then -- [WHOLE SONG]


---Get no of patterns:

local status_number = 0


for patterns = 1, total_patterns do
  pattern_index = patterns
  status_number = status_number +1
  renoise.app():show_status("Clear Junk Data Tool: (Processing Pattern : "
  ..status_number.." / "..total_patterns..")")
  
  for my_note_tracks = 1, all_note_tracks do  --tracks
    local current_pattern_track = renoise.song().patterns[pattern_index].tracks[my_note_tracks]

   --"iterate" downwards: 1 column at a time
   ---------------------------------------------

    for note_col = 1,12 do
      current_note_holder = 0 --reset for each column
      
      for line_index = 1, pattern_length do
        local note_columns = current_pattern_track:line(line_index).note_columns --table

       --if second note_off in column found then delete
        if current_note_holder == NOTE_OFF and note_columns[note_col].note_value == NOTE_OFF then
          note_columns[note_col].note_value = EMPTY_NOTE_CELL 
        end
   
       --note_off found so initialise holder
        if note_columns[note_col].note_value == NOTE_OFF then
          current_note_holder = NOTE_OFF
  
       --else note found so reset holder
        elseif note_columns[note_col].note_value < NOTE_OFF then
           current_note_holder = 0
        end 
      end --for "lines in column"
    end --for "each column"
  end --for "each track in pattern"
end --for "each pattern in song"
end --if --popup




elseif vb.views["switch"].value == 1 then --[meta]

-------------------------------------------------------------
--CLEAR VOL PAN etc.
-------------------------------------------------------------
-- 255 = empty vol,pan
--   0 = delay set to 0 

if vb.views["popup"].value == 1 then --[Meta TRACK IN PATTERN]
--iterate and clear orphaned meta data
  for pos,line in pattern_iter:note_columns_in_pattern_track(pattern_index,track_index) do

    if line.note_value > 119 then --note present

      line.instrument_value = 255
      line.volume_value = 255
      line.panning_value = 255
      if line.note_value ~= NOTE_OFF then
        line.delay_value = 00
      end
    end
  end
  
elseif vb.views["popup"].value == 2 then --[meta SELECTION IN PATTERN] 
  
  for pos,line in pattern_iter:note_columns_in_pattern(pattern_index) do
   
      
    if line.is_selected then
      if line.note_value > 119 then --note present

        line.instrument_value = 255
        line.volume_value = 255
        line.panning_value = 255
        if line.note_value ~= NOTE_OFF then --leave note-off delay values
          line.delay_value = 00
        end
      end
    end
  end
  
  
  
elseif vb.views["popup"].value == 3 then --[meta PATTERN] 
  
  for pos,line in pattern_iter:note_columns_in_pattern(pattern_index) do

    if line.note_value > 119 then --note present

      line.instrument_value = 255
      line.volume_value = 255
      line.panning_value = 255
      if line.note_value ~= NOTE_OFF then --leave note-off delay values
        line.delay_value = 00
      end
    end
  end

elseif vb.views["popup"].value == 4 then --[Meta WHOLE TRACK]

local pos_holder = 0
local position_in_sequencer = 0

for pos,line in pattern_iter:note_columns_in_track(track_index) do

-- Get current pattern for status i.e.:(Processing Pattern 1/100) 
-- inc. and conditionals needed as pos.pattern returns the number
-- of the pattern and not the position in the sequencer.  
  if pos.pattern ~= pos_holder then
    position_in_sequencer = position_in_sequencer + 1
    pos_holder = pos.pattern
    renoise.app():show_status("Clear Junk Data Tool: (Processing Pattern : "
    ..position_in_sequencer.." / "..total_patterns..")")
 end  

    if line.note_value > 119 then --note present

      line.instrument_value = 255
      line.volume_value = 255
      line.panning_value = 255
      if line.note_value ~= NOTE_OFF then --leave note-off delay values
        line.delay_value = 00
      end
    end
  end
  
  
  
elseif vb.views["popup"].value == 5 then --[PATTERNS FROM..]

local reversed_box_values = false
local user_chosen_range_start = vb.views["box1"].value + 1
local user_chosen_range_end = vb.views["box2"].value + 1

-- when box 1 is greater than box 2 then swap
if user_chosen_range_start > user_chosen_range_end then
  reversed_box_values = true
  user_chosen_range_start = vb.views["box2"].value + 1
  user_chosen_range_end = vb.views["box1"].value + 1   
end

for pattern = user_chosen_range_start,user_chosen_range_end do 
  for pos,line in pattern_iter:note_columns_in_pattern(pattern) do
  --status
  renoise.app():show_status("Clear Junk Data Tool: (Processing Pattern : "
    ..pattern.." / "..user_chosen_range_end..")")

    if line.note_value > 119 then --note present

      line.instrument_value = 255
      line.volume_value = 255
      line.panning_value = 255
      if line.note_value ~= NOTE_OFF then --leave note-off delay values
        line.delay_value = 00
      end --if
    end --if
  end --for
  
  if total_patterns == 1 then --hack due to max vb has to be 1
    break
  end
end  --for

elseif vb.views["popup"].value == 6 then --[Meta WHOLE SONG]

local pos_holder = 0
local position_in_sequencer = 0

for pos,line in pattern_iter:note_columns_in_song() do
 
-- Get current pattern for status i.e.:(Processing Pattern 1/100) 
-- inc. and conditionals needed as pos.pattern returns the number
-- of the pattern and not the position in the sequencer.
  if pos.pattern ~= pos_holder then
    position_in_sequencer = position_in_sequencer + 1
    pos_holder = pos.pattern
    renoise.app():show_status("Clear Junk Data Tool: (Processing Pattern : "
    ..position_in_sequencer.." / "..total_patterns..")")
 end  
     
  
  
    if line.note_value > 119 then --note present

      line.instrument_value = 255
      line.volume_value = 255
      line.panning_value = 255
      if line.note_value ~= NOTE_OFF then --leave note-off delay values
        line.delay_value = 00
      end
    end
  end



end --if [popup] 


end--[ switch]


renoise.app():show_status("Clear Junk Data Tool: (Completed)")
end --notifier function()
------------------------------------------------------                         
    }
   }
  }
 }
 
 --key Handler
local function my_keyhandler_func(dialog, key)

 if not (key.modifiers == "" and key.name == "esc") then
    return key
 else
   dialog:close()
 end
end

my_dialog = renoise.app():show_custom_dialog(title, dialog_content,my_keyhandler_func)

end --main



